INTERFACE Uucontext;

FROM Ctypes IMPORT int, long, char_star, unsigned_int;
FROM Utypes IMPORT size_t;

(* ucontext.h *)

TYPE

  sigset_t = ARRAY [0..3] OF unsigned_int;

  struct_sigaltstack = RECORD
    ss_sp      : char_star;
    ss_size    : size_t;
    ss_flags   : int;
  END;
  stack_t = struct_sigaltstack;

  register_t = long;
  mcontext_t = RECORD
    mc_onstack : register_t;
    mc_rdi     : register_t;
    mc_rsi     : register_t;
    mc_rdx     : register_t;
    mc_rcx     : register_t;
    mc_r8      : register_t;
    mc_r9      : register_t;
    mc_rax     : register_t;
    mc_rbx     : register_t;
    mc_rbp     : register_t;
    mc_r10     : register_t;
    mc_r11     : register_t;
    mc_r12     : register_t;
    mc_r13     : register_t;
    mc_r14     : register_t;
    mc_r15     : register_t;
    mc_trapno  : register_t;
    mc_addr    : register_t;
    mc_flags   : register_t;
    mc_err     : register_t;
    mc_rip     : register_t;
    mc_cs      : register_t;
    mc_rflags  : register_t;
    mc_rsp     : register_t;
    mc_ss      : register_t;
    mc_len     : long;
    mc_fpformat : long;
    mc_ownedfp : long;
    mc_fpstate : ARRAY[0..63] OF long;
    mc_spare   : ARRAY[1..8] OF long;
  END;

  struct_ucontext = RECORD
    uc_sigmask : sigset_t;
    uc_mcontext: mcontext_t;
    uc_link    : UNTRACED REF struct_ucontext;
    uc_stack   : stack_t;
    uc_flags   : int;
    uc_spare  : ARRAY [1..4] OF int;
  END;
  ucontext_t = struct_ucontext;
  ucontext_t_star = UNTRACED REF ucontext_t;

<*EXTERNAL*>
PROCEDURE swapcontext(VAR oucp, ucp: ucontext_t): int;

<*EXTERNAL*>
PROCEDURE getcontext(VAR ucp: ucontext_t): int;

<*EXTERNAL*>
PROCEDURE setcontext(VAR ucp: ucontext_t): int;

END Uucontext.
